%Kristen Parrish
%3/21/09
%Computational Emag, FDTD project
clear
%pml boundary size
pml = 8
%# of time steps between requested times
ts=5
%last time step requested
last = 400
%manually input from dt_factor * sqrt(dx**2 + dy**2)/(2*c0)
dt=1*(0.5/500)/(sqrt(2)*299792458)

for i=1:9
    %load results of FDTD
    Ez_UX = load(['UX_Exp00',num2str(i),'Ez.txt']);
    Ez_SF = load(['SF_Exp00',num2str(i),'Ez.txt']);
    Ez_RefUX = load(['RefUX_Exp00',num2str(i),'Ez.txt']);
    Ez_RefSF = load(['RefSF_Exp00',num2str(i),'Ez.txt']);
    Ez_CFS = load(['CFS_Exp00',num2str(i),'Ez.txt']);
    %cut out PML region
    Ez_UX = Ez_UX(pml:length(Ez_UX)-pml,pml:length(Ez_UX)-pml)
   Ez_CFS = Ez_CFS(pml:length(Ez_CFS)-pml,pml:length(Ez_CFS)-pml)
    %Ez_SF = Ez_SF(pml-1:length(Ez_SF)-pml+1,pml-1:length(Ez_SF)+1-pml)
    Ez_SF = Ez_SF(pml:length(Ez_SF)-pml,pml:length(Ez_SF)-pml)
     Ez_RefUX = Ez_RefUX(pml:length(Ez_RefUX)-pml,pml:length(Ez_RefUX)-pml)
    Ez_RefSF = Ez_RefSF(pml:length(Ez_RefSF)-pml,pml:length(Ez_RefSF)-pml)
     num1(i) = norm(Ez_UX - Ez_RefUX)
     num2(i) = norm(Ez_SF - Ez_RefSF)
     num3(i) = norm(Ez_CFS - Ez_RefUX)
     refux(:,:,i) = Ez_RefUX
     refsf(:,:,i) = Ez_RefSF
    
  end
for i=10:71
        %load results of FDTD
    Ez_UX = load(['UX_Exp0',num2str(i),'Ez.txt']);
    Ez_SF = load(['SF_Exp0',num2str(i),'Ez.txt']);
    Ez_RefUX = load(['RefUX_Exp0',num2str(i),'Ez.txt']);
    Ez_RefSF = load(['RefSF_Exp0',num2str(i),'Ez.txt']);
     Ez_CFS = load(['CFS_Exp0',num2str(i),'Ez.txt']);
    %cut out PML region
    Ez_UX = Ez_UX(pml:length(Ez_UX)-pml,pml:length(Ez_UX)-pml)
   Ez_CFS = Ez_CFS(pml:length(Ez_CFS)-pml,pml:length(Ez_CFS)-pml)
    Ez_SF = Ez_SF(pml:length(Ez_SF)-pml,pml:length(Ez_SF)-pml)

     Ez_RefUX = Ez_RefUX(pml:length(Ez_RefUX)-pml,pml:length(Ez_RefUX)-pml)
    Ez_RefSF = Ez_RefSF(pml:length(Ez_RefSF)-pml,pml:length(Ez_RefSF)-pml)
  
    num1(i) = norm(Ez_UX - Ez_RefUX)
     num2(i) = norm(Ez_SF - Ez_RefSF)
     num3(i) = norm(Ez_CFS - Ez_RefUX)
     refux(:,:,i) = Ez_RefUX
     refsf(:,:,i) = Ez_RefSF
end

 xSF = norm(max(refsf,[],3))
 xUX = norm(max(refux,[],3)) 
 error_ux = 20*log10(num1/xUX)
 error_sf = 20*log10(num2/xSF)
 error_cfs = 20*log10(num3/xUX)
% error_cfs = 20*log10(num3/x)
save 'sf.mat' error_sf
save 'ux.mat' error_ux

myPlot = figure
time = linspace(0,350,71)
plot(time,error_sf(1:71), '+', time, error_ux(1:71), time, error_cfs(1:71),'o')
ylabel('Reflection Error [dB]')
xlabel('Time steps')
legend('Split-field','Uniaxial', 'CFS')
axis([0,350,-250,0])
set(myPlot,'Position',[400,400,400,250])
